/* ¦¦¦¦¦¦¦¦¦¦¦¦¦ ARMOSY-2 Example ¦¦¦¦¦¦¦¦¦¦¦¦
Control GSM SIM800 using AT commands, display response
Hardware: ARMOSY-2
Version HW: 2.12
Create: 06.04.2016

¦¦¦¦¦¦¦¦¦¦¦¦¦ TERMINAL CONNECTION ¦¦¦¦¦¦¦¦¦¦¦¦
63 - IN POWER, VCC min 8V/1A!
64 - IN POWER, -"-
77 - Connection USB Special Cable!!! <-> USB PC

¦¦¦¦¦¦¦¦¦¦¦¦¦ BASIC AT COMMAND ¦¦¦¦¦¦¦¦¦¦¦¦
AT+CREG? - Registration  network
AT+CSQ - Power Signal GSM (10-30 OK)
AT+COPS? - OperatorAT+CLIP=1 - Calling Line Identification Presentation
ATD 724008???; - Calling Phone Number 
AT+CLTS=1, AT+CENG=3, AT+CCLK? - Exact time 24hAT+CIPGSMLOC=1,1 - Position BTS
*/


// ¦ LIBRARY
#include <UTFT.h>

// ¦ DECLARATIONS
UTFT  myGLCD(ITDB24,38,39,40,41); // RS, WR, CS, REST
extern uint8_t BigFont[]; // UTFT Fonds
String command;  //String to hold commands sent to SIM800

#define Serial SerialUSB //USB PC
#define SIM800 Serial2 // SIM800 serial 2
#define PC Serial //PC serial



// ¦¦¦¦¦¦¦¦¦¦¦¦¦ SETUP ¦¦¦¦¦¦¦¦¦¦¦¦

void setup()
{

// ¦ TOUCH, UTFT
  myGLCD.InitLCD();               // Initialization LCD              
  myGLCD.clrScr();                // Clear Screen
  myGLCD.fillScr(VGA_WHITE);      // VGA Background Transparency
  myGLCD.setColor(0, 0, 0);       // Black Fonds
  myGLCD.setBackColor(255, 255, 255); // White Background
  myGLCD.setFont(BigFont);        // Select Font 

// ¦ SERIAL  
  PC.begin(115200); // speed serial 0 (PC)
  SIM800.begin(115200); // speed serial 2 (SIM800)

// ¦ HEADER  

  myGLCD.print("ARMOSY2 - SW0003", CENTER, 10);             
  myGLCD.print("www.hwpro.cz", CENTER, 220);             



// ¦ COMMAND  
  
  SIM800.println("AT+CLIP=1");  //set CLIP Wait Ring
}

// ¦¦¦¦¦¦¦¦¦¦¦¦¦ MAIN ¦¦¦¦¦¦¦¦¦¦¦¦

void loop()
{

 while(PC.available()>0)  // RX data PC
 SIM800.write(PC.read()); // SIM800 <= PC 
 
 if(SIM800.available()>0)
 {
   char c = SIM800.read(); // PC <= SIM800 
   Serial.write(c);
   if(c == '\n')
   {
     ParseCmd(command);
     command = "";
   }
   else if (c != '\r')command += c;
 }
}
 
 // Read command SIM800
void ParseCmd(String com)
{
    String cmd = com.substring(com.indexOf(":")+1); // cmd <= serial 
    myGLCD.print(cmd, 10, 120); // Print UTFT
}
